#include "StdAfx.h"
#include "MenuItemStoredValue.h"

//using namespace Sim_UiSubjectSim_NS;
using namespace System::Text::RegularExpressions;



/******************************************************************
MenuItemStoredValue: CONSTRUCTORS
*******************************************************************/
MenuItemStoredValue::MenuItemStoredValue()
{
  display_name_="";
  item_stored_ = new MenuItemVariable();
}

MenuItemStoredValue::MenuItemStoredValue(System::String^ text,MenuItemVariable* item):ToolStripMenuItem(text) {
  setItemStored(item);
}

MenuItemStoredValue::MenuItemStoredValue(System::String^ text):ToolStripMenuItem(text) {
  item_stored_ = new MenuItemVariable();
  display_name_=text;
}

MenuItemStoredValue::MenuItemStoredValue(System::String^ text,MenuItemVariable::StoredType stored_type):ToolStripMenuItem(text) {
  item_stored_ = new MenuItemVariable();
  display_name_=text;
}

MenuItemStoredValue::MenuItemStoredValue(MenuItemStoredValue^ old)
{
  item_stored_ = new MenuItemVariable();
  setDisplayName(old->getDisplayName());
}

MenuItemStoredValue::~MenuItemStoredValue()
{
  delete item_stored_;
  item_stored_ = nullptr;
}

/******************************
MenuItemStoredValue::PRIVATE FUNCTIONS
******************************/

/******************************
MenuItemStoredValue::ACCESS FUNCTIONS
******************************/
MenuItemVariable* 
MenuItemStoredValue::getItemStored() {
  return item_stored_;
}
void 
MenuItemStoredValue::setItemStored(MenuItemVariable *item)  {
  delete item_stored_;
  item_stored_ = new MenuItemVariable();
}

System::String^ 
MenuItemStoredValue::getDisplayName() {
  if ( display_name_ != nullptr)  {
    return display_name_;
  }
  else  {
    return this->Text;
  }
}

void 
MenuItemStoredValue::setDisplayName(System::String^ display_name) {
  display_name_=display_name;
}

/******************************
MenuItemStoredValue::PUBLIC FUNCTIONS
******************************/

bool 
MenuItemStoredValue::hasValidItemStored() {

  if(item_stored_ != nullptr)  {
    return true;
  }
  else  {
    return false;
  }
}

void
MenuItemStoredValue::OnPaint(System::Windows::Forms::PaintEventArgs ^e) {

  System::Diagnostics::Debug::Write("painting the item " + this->Text + "\n");
  __super::OnPaint(e);

}

