#pragma once

#include "ComboMenuStrip.h"
#include "MenuItemStoredValue.h"

using namespace Syncfusion::Windows::Forms::Grid;


 public ref class SumCalMenuSelectedArgs : public System::EventArgs {
private:
  bool all_items_selected_;

public:
  // Constructor
  SumCalMenuSelectedArgs(bool all_items_selected) {all_items_selected_ = all_items_selected;}

  void setAllItemsSelected(bool all_items_selected) {all_items_selected_ = all_items_selected;}
  bool getAllItemsSelected(){return all_items_selected_;}
};

public delegate void itemsSelectedEventHandler(System::Object^ sender, SumCalMenuSelectedArgs^ e);

public ref class SumCalMenuTable : public Syncfusion::Windows::Forms::Grid::GridControl {
  //ref class SumCalMenuTable : public UiTable {

public:

  // Table columns.
  enum class SumCols {BLANK         = 0,
    VARIABLE      = 1,
    CASE          = 2,
    VECTOR        = 3,
    IDENTIFIER    = 4};

private:

  static enum class MasterCol {
    NONE       = 0,
    VECTOR     = 1,
    IDENTIFIER = 2};

    //member variables
    //BaseVector<SummaryCalculatorVariable::Ptr> *variables_;

    System::String^ current_case_filter_;
    System::String^ current_vector_filter_;
    System::String^ current_identifier_filter_;

    static System::String^ CASE_DEFAULT_TOOL_TIP = gcnew System::String("Select the case");
    static System::String^ VECTOR_DEFAULT_TOOL_TIP = gcnew System::String("Select the vector");
    static System::String^ IDENTIFIER_DEFAULT_TOOL_TIP =gcnew System::String("Select the identifier");

    ComboMenuStrip^  menu_combo_active_;
    ComboMenuStrip^  menu_combo_draw_;

    /*GridStyleInfo^                                    style_vector_;
    Sim_UiSubjectSim_NS::BaseMenuCellStyleProperties^ sp_vector_;
    GridStyleInfo^                                    style_identifier_;
    Sim_UiSubjectSim_NS::BaseMenuCellStyleProperties^ sp_identifier_;
    GridStyleInfo^                                    style_case_;
    Sim_UiSubjectSim_NS::BaseMenuCellStyleProperties^ sp_case_;*/

    bool lhs_variable_present_; //tracks whether we should consider the first row to be a lhs variable
    bool is_workflow_; //tracks whether we should add variables to case and identifier drop downs 

    //void    makeHeader(int row, int col, System::String^ label, System::String^ tooltip, int width);
    //void    setStyleRange(UiTableRange ^range, UiBaseControls_NS::UiTableStyle style);
    System::String^ getString(int row, int col);
    System::Object^ getValueRowCol(int row, int col);


public:

  const static int CELL_WIDTH=150;
  const static int CELL_HEIGHT=25;
  const static int COMBO_MENU_WIDTH  = 147;
  const static int COMBO_MENU_HEIGHT = 25;


private:

  //BOLC TEMP
  void locationChanged(System::Object^ sender, System::EventArgs^ event_args);

  //member functions
  void setBasicCellStyle(GridStyleInfo^ style);
  void makeComboMenuListRow(int row);

  void itemSelected(System::Object^ sender, MenuItemSelectedEventArgs^ event_args);

  System::Void gridResizingColumns(System::Object^ sender,Syncfusion::Windows::Forms::Grid::GridResizingColumnsEventArgs^  e);
  System::Void gridResizingRows(System::Object^ sender,Syncfusion::Windows::Forms::Grid::GridResizingRowsEventArgs^  e);

  void initialiseMenuStripControls();
  //void insertVariableRow(SummaryCalculatorVariable::Ptr args, SummaryCalculatorExpression::Ptr previous_expression);

  //void clearStyles();
  //void getStyles(int row);

  /*void setCaseColumnMenu(int row);
  void setVectorColumnMenu(bool filter_column, bool clear_selection,bool new_vector_option);
  void setIdentifierColumnMenu(bool filter_column, bool clear_selection,int row);
  void resetVectorIdentifier(int row);
  void addResetItem(MenuItemStoredValue^ base_menu);
  void itemSelectedAction(int row_selected, int col_selected,MenuItemVariable *clicked_menu_item,bool pop_up_dialogs);
  void propagateSelection(int row,int col,MenuItemVariable *menu_item);
  void propagateAllInFolderSelection(int col);*/

  //functions to test whether cells have been selected by the user
  bool isAllSelected();
  bool isRowSelected(int row);
  bool isItemSelected(int row, int col);

  //functions to set the selection of the table after a parse expression event - preserves the old selections
  //void setSelections(int row, SummaryCalculatorVariable::Ptr args,const SummaryCalculatorExpression::Ptr previous_expresion);
  //bool setSelection(int row,int col, Sim_UiSubjectSim_NS::MenuItemVariable menu_variable);
  //const SummaryCalculatorVariable* getPreviousMatchingRow(const CString name,const SummaryCalculatorExpression::Ptr previous_expresion);
  //bool setNewCaseSelection(SummaryCalculatorExpression::Ptr expression);
  //bool setNewVectorSelection(const SummaryCalculatorExpression::Ptr expression);
  //void makeHeaders();

  void applyFilter(int col_index);
  void applyFilter(int col_index,int row_index);
  void resetFilters();

public:

  // Constructor.
  SumCalMenuTable();
  ~SumCalMenuTable();


  // FUNCTION FROM UiTable.
  void onInitialize();

  //populate the table 
  bool populateTable();

  void clearTable();

  event itemsSelectedEventHandler ^itemsSelected;

  //bool getCurrentExpression(SummaryCalculatorExpression::Ptr calc_expression);

  void applyFilters(System::String^ case_filter,System::String^ vector_filter,System::String^ identifier_filter);

};

