#include "UiMenuListCell.h"



//#include <Sim/UiSubjectSim/ComboMenuStrip.h>

//#include <Sim/UiSubjectSim/BaseMenuCellStyleProperties.h>
//#include <Sim/UiSubjectSim/UiMenuListCell.h>

//#include <core/UiBase/UiIconKit.h>

//#include <Sim/UiSubjectSim/SumCalMenuTable.h>


using namespace Syncfusion::Windows::Forms::Grid;
using namespace System::Drawing;
using namespace System::Windows::Forms;



  /******************************************************************
  UiMenuListCell : Constructors
  *******************************************************************/

UiMenuListCell::UiMenuListCell(GridModel ^grid) : 
GridGenericControlCellModel(grid) {
}

UiMenuListCell::UiMenuListCell(msSerializationInfo ^info, msStreamingContext context) :
GridGenericControlCellModel(info, context) {
}

/******************************************************************
UiMenuListCell : FUNCTIONS FROM GridCellModelBase
*******************************************************************/

GridCellRendererBase^ 
UiMenuListCell::CreateRenderer(sfGridControlBase ^control) {

  return gcnew UiMenuListCellRenderer(control, this);
}

void 
UiMenuListCell::InitializeMenu(ComboMenuStrip^ menu_strip, Syncfusion::Windows::Forms::Grid::GridStyleInfo^ style)  {

  //TO DO!
  
  MenuItemStoredValue  ^base_menu = gcnew MenuItemStoredValue("Click here!");
  base_menu->AutoSize = true;
  //base_menu.Width = 150;
  //base_menu.Height = 25;


  //add some items to the menu
  for(int i = 0 ; i < 3; i++) {

    MenuItemStoredValue ^folder = gcnew MenuItemStoredValue("Folder");

    folder->AutoSize = true;
    //folder.Width = 400;
    //folder.Height = 25;

    for(int j=0;j<1000;j++)  {
      MenuItemStoredValue ^item = gcnew MenuItemStoredValue("Item " + Convert::ToString(j));
      item->AutoSize = true;
      //item.Width = 150;
      //item.Height = 25;
      folder->DropDownItems->Add(item);
    }
    base_menu->DropDownItems->Add(folder);
  }

  // menu_strip->Items->Add(base_menu);


  //BaseMenuCellStyleProperties^ base_menu_style = gcnew BaseMenuCellStyleProperties(style);
  menu_strip->setBaseMenuItem(base_menu);
}


/******************************************************************
UiMenuListCellRenderer : Constructors
*******************************************************************/

UiMenuListCellRenderer::UiMenuListCellRenderer(sfGridControlBase ^grid, sfGridCellModelBase ^cell_model) : 
GridGenericControlCellRenderer(grid, cell_model) {
}

/******************************************************************
UiMenuListCellRenderer : EVENT HANDLERS
*******************************************************************/
void 
UiMenuListCellRenderer::menuItemClicked(System::Object^ sender, MenuItemSelectedEventArgs^ event_args)
{
  
  //obtain the current cell style
  /*Syncfusion::Windows::Forms::Grid::GridStyleInfo^ style = this->StyleInfo;
  BaseMenuCellStyleProperties^ base_menu_style = gcnew BaseMenuCellStyleProperties(style);
  
  MenuItemStoredValue^ base_menu_item=base_menu_style->BaseMenu;

  //set the unique tag and display name for the base menu item
  //not if this is a new_case or new_vector stored type - in this case the previous data is extracted
  //from the base menu item
  if(!(event_args->getMenuVariable()->getStoredType() == MenuItemVariable::StoredType::NEW_CASE || event_args->getMenuVariable()->getStoredType() == MenuItemVariable::StoredType::NEW_VECTOR)) {

    base_menu_item->setItemStored(event_args->getMenuVariable());
    base_menu_item->Text=event_args->getDisplayName();
    base_menu_item->setDisplayName(event_args->getDisplayName());
    base_menu_style->BaseMenu = base_menu_item;
  } 

  */

  GridCurrentCell^ curr_cell = this->Grid->CurrentCell;
  event_args->setColumn(curr_cell->ColIndex);
  event_args->setRow(curr_cell->RowIndex);

  itemSelected(this,event_args);
  
}

/******************************************************************
UiMenuListCellRenderer : FUNCTIONS FROM GridCellRendererBase
*******************************************************************/
void
UiMenuListCellRenderer::OnDraw(msGraphics ^graphics, msRectangle client_rectangle, int row, int col, sfGridStyleInfo ^style) {

  if (this->ShouldDrawFocused(row, col))
  {
    style->Control = menu_combo_active_;
    UiMenuListCell::InitializeMenu(menu_combo_active_, style);
    menu_combo_active_->Enabled=style->Enabled;
  }
  else
  {
    style->Control = menu_combo_draw_; 
    UiMenuListCell::InitializeMenu(menu_combo_draw_, style);
    menu_combo_draw_->Enabled=style->Enabled;
  }

  __super::OnDraw(graphics,client_rectangle,row,col,style);
}

void 
UiMenuListCellRenderer::OnActivated()
{
  // Works around some interaction problem with PropertyGrid specific to this sample: force redrawing of
  // calendar after property grid was refreshed.
  GridCurrentCell^ curr_cell = this->Grid->CurrentCell;
  System::Diagnostics::Debug::Write("on activate " + System::Convert::ToString(curr_cell->RowIndex) + " " + System::Convert::ToString(curr_cell->ColIndex) +"\n");

  __super::OnActivated();
}

/******************************************************************
UiMenuListCell : PUBLIC FUNCTIONS 
*******************************************************************/

//method used to initialize things. Should be call immediately after adding the derived
//cell model to the grid's CellModels collection.
void 
UiMenuListCellRenderer::InitCellPanels(ComboMenuStrip^ activeControl, ComboMenuStrip^ staticControl)
{
  menu_combo_active_=activeControl;
  menu_combo_draw_=staticControl;

  SupportsFocusControl = true;
  FixControlParent(menu_combo_draw_);
  SetControl(menu_combo_active_);

  this->Grid->Controls->Add(menu_combo_active_); 
  this->Grid->Controls->Add(menu_combo_draw_);

  menu_combo_active_->menuSelected +=gcnew MenuItemSelectedEventHandler(this,&UiMenuListCellRenderer::menuItemClicked);

  menu_combo_active_->AutoSize=false;
  menu_combo_active_->GripMargin = System::Windows::Forms::Padding(0);
  menu_combo_active_->BackColor = System::Drawing::SystemColors::Control;

  menu_combo_draw_->AutoSize=false;
  menu_combo_draw_->GripMargin = System::Windows::Forms::Padding(0);
  menu_combo_draw_->BackColor = System::Drawing::SystemColors::Control;
}


