#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Diagnostics;
using namespace System::Windows::Forms;
using namespace Syncfusion::Windows::Forms::Grid;

#include "MenuItemSelectedEventArgs.h"
#include "MenuItemStoredValue.h"
#include "ComboMenuStrip.h"


  //private delegate void MenuItemSelectedEventHandler(System::Object^ sender, MenuItemSelectedEventArgs^ e);

  [System::Serializable]
  public ref class UiMenuListCell : public Syncfusion::Windows::Forms::Grid::GridGenericControlCellModel {

  protected:
    // Type definitions
    typedef System::Runtime::Serialization::SerializationInfo       msSerializationInfo;
    typedef System::Runtime::Serialization::StreamingContext        msStreamingContext;

    typedef Syncfusion::Windows::Forms::Grid::GridCellRendererBase  sfGridCellRendererBase;
    typedef Syncfusion::Windows::Forms::Grid::GridControlBase       sfGridControlBase;

    // Protected Constructor
    UiMenuListCell(msSerializationInfo ^info, msStreamingContext context);

  public:
    // Public Constructor
    UiMenuListCell(GridModel ^grid);

    // FUNCTIONS FROM GridCellModelBase
    virtual sfGridCellRendererBase^ CreateRenderer(sfGridControlBase ^control) override;

    static void InitializeMenu(ComboMenuStrip^ menu_strip, Syncfusion::Windows::Forms::Grid::GridStyleInfo^ style);

  };

  public ref class UiMenuListCellRenderer : public Syncfusion::Windows::Forms::Grid::GridGenericControlCellRenderer {
  protected:
    // Type definitions
    typedef System::Drawing::Rectangle                            msRectangle;
    typedef System::Drawing::Graphics                             msGraphics;
    typedef Syncfusion::Windows::Forms::Grid::GridControlBase                   sfGridControlBase;
    typedef Syncfusion::Windows::Forms::Grid::GridCellModelBase                 sfGridCellModelBase;
    typedef Syncfusion::Windows::Forms::Grid::GridPrepareViewStyleInfoEventArgs sfGridPrepareViewStyleInfoEventArgs;
    typedef Syncfusion::Windows::Forms::Grid::GridStyleInfo      sfGridStyleInfo;

    ComboMenuStrip^  menu_combo_active_;
    ComboMenuStrip^  menu_combo_draw_;

    // FUNCTIONS FROM GridCellRendererBase
    virtual void OnDraw(msGraphics ^graphics, msRectangle client_rectangle, int row, int col, sfGridStyleInfo ^style) override;
    virtual void         OnActivated() override;

  internal:

    //events
     void menuItemClicked(System::Object^ sender, MenuItemSelectedEventArgs^ e);
     event MenuItemSelectedEventHandler^ itemSelected;

  public:
    // Constructor
    UiMenuListCellRenderer(sfGridControlBase ^grid, sfGridCellModelBase ^cell_model);

    void InitCellPanels(ComboMenuStrip^ activeControl, ComboMenuStrip^ staticControl);
  };
